/**
 * 
 */
package com.wieseke.cptk.input.action;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchPart;

import com.wieseke.cptk.common.action.CommonAction;
import com.wieseke.cptk.common.selection.CophylogenyViewerSelection;
import com.wieseke.cptk.common.viewer.CophylogenyViewer;
import com.wieseke.cptk.input.selection.InputNodeControlSelection;
import com.wieseke.cptk.input.viewer.InputCophylogenyViewer;
import com.wieseke.cptk.input.viewer.InputNodeControl;

/**
 * @author Nicolas Wieseke
 * 
 */
public abstract class InputAction extends CommonAction {

	/**
	 * the input node control
	 */
	protected InputNodeControl node;

	/**
	 * constructor
	 * 
	 * @param text
	 */
	public InputAction(String text) {
		super(text);
		setEnabled(false);
	}

	/**
	 * constructor
	 * 
	 * @param text
	 * @param style
	 */
	public InputAction(String text, int style) {
		super(text, style);
		setEnabled(false);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.wieseke.cptk.common.action.CommonAction#selectionChanged(org.eclipse
	 * .ui.IWorkbenchPart, org.eclipse.jface.viewers.ISelection)
	 */
	
	public void selectionChanged(IWorkbenchPart part, ISelection selection) {
		this.part = part;
		if (!selection.isEmpty()) {
			if (selection instanceof CophylogenyViewerSelection) {
				CophylogenyViewer viewer = ((CophylogenyViewerSelection) selection)
						.getCophylogenyViewer();
				if (viewer instanceof InputCophylogenyViewer) {
					this.viewer = viewer;
				}
			}
			if (selection instanceof InputNodeControlSelection) {
				this.node = ((InputNodeControlSelection) selection)
						.getInputNodeControl();
			}
		}
	}

	/**
	 * @return the viewer
	 */
	protected InputCophylogenyViewer getViewer() {
		return (InputCophylogenyViewer) this.viewer;
	}
}
