/**
 * 
 */
package com.wieseke.cptk.input.action;

import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchPart;

import com.wieseke.cptk.common.selection.CophylogenyViewerSelection;
import com.wieseke.cptk.common.viewer.CophylogenyViewer;
import com.wieseke.cptk.input.selection.InputNodeControlSelection;
import com.wieseke.cptk.input.viewer.InputCophylogenyViewer;

/**
 * @author Nicolas Wieseke
 * 
 */
public abstract class InputPropertyListenerAction extends InputAction {

	/**
	 * listener for the property change event
	 */
	protected IPropertyChangeListener propertyChangeListener;

	/**
	 * constructor
	 * 
	 * @param text
	 */
	public InputPropertyListenerAction(String text) {
		super(text);
		setEnabled(false);
	}

	/**
	 * constructor
	 * 
	 * @param text
	 * @param style
	 */
	public InputPropertyListenerAction(String text, int style) {
		super(text, style);
		setEnabled(false);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.wieseke.cptk.common.action.CommonAction#selectionChanged(org.eclipse
	 * .ui.IWorkbenchPart, org.eclipse.jface.viewers.ISelection)
	 */
	
	public void selectionChanged(IWorkbenchPart part, ISelection selection) {
		this.part = part;
		if (!selection.isEmpty()) {
			if (selection instanceof CophylogenyViewerSelection) {
				CophylogenyViewer viewer = ((CophylogenyViewerSelection) selection)
						.getCophylogenyViewer();
				if (viewer instanceof InputCophylogenyViewer) {
					if (!viewer.equals(this.viewer)) {
						if (this.viewer != null) {
							this.viewer
									.removePropertyChangeListener(this.propertyChangeListener);
						}
						this.viewer = viewer;
						this.viewer
								.addPropertyChangeListener(this.propertyChangeListener);
					}
				}
			}
			if (selection instanceof InputNodeControlSelection) {
				this.node = ((InputNodeControlSelection) selection)
						.getInputNodeControl();
			}
		}
	}

	/**
	 * @return the viewer
	 */
	protected InputCophylogenyViewer getViewer() {
		return (InputCophylogenyViewer) this.viewer;
	}
}
