/**
 * 
 */
package com.wieseke.cptk.input.action;

import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchPart;

import com.wieseke.cptk.input.constants.InputViewerConstants;

/**
 * @author Nicolas Wieseke
 * 
 */
public class SelectEditModeRearrangeChildPositionAction extends
		InputPropertyListenerAction {

	/**
	 * default constructor
	 * 
	 * @param text
	 */
	public SelectEditModeRearrangeChildPositionAction(String text) {
		super(text, AS_RADIO_BUTTON);
		this.propertyChangeListener = new IPropertyChangeListener() {
			/*
			 * (non-Javadoc)
			 * 
			 * @see
			 * org.eclipse.jface.util.IPropertyChangeListener#propertyChange
			 * (org.eclipse.jface.util.PropertyChangeEvent)
			 */
			
			public void propertyChange(PropertyChangeEvent event) {
				if (event.getProperty().equals(
						InputViewerConstants.PROPERTY_EDIT_MODE)
						&& !event.getNewValue().equals(event.getOldValue())) {
					setChecked((Integer) event.getNewValue() == InputViewerConstants.EDIT_MODE_REARRANGE_CHILD_POSITION);
				}
			}
		};
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 */
	
	public void run() {
		if (this.viewer != null) {
			getViewer().setEditMode(
					InputViewerConstants.EDIT_MODE_REARRANGE_CHILD_POSITION);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.wieseke.cptk.input.action.InputPropertyListenerAction#selectionChanged
	 * (org.eclipse.ui.IWorkbenchPart, org.eclipse.jface.viewers.ISelection)
	 */
	
	public void selectionChanged(IWorkbenchPart part, ISelection selection) {
		super.selectionChanged(part, selection);
		if (this.viewer != null)
			setChecked((getViewer().getEditMode() == InputViewerConstants.EDIT_MODE_REARRANGE_CHILD_POSITION));
	}
}