/**
 * 
 */
package com.wieseke.cptk.input.preferences;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.preference.PreferenceConverter;
import org.eclipse.ui.PlatformUI;

/**
 * @author Nicolas Wieseke
 * 
 */
public class InputPreferenceInitializer extends AbstractPreferenceInitializer {

	public InputPreferenceInitializer() {
		super();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @seeorg.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#
	 * initializeDefaultPreferences()
	 */
	
	public void initializeDefaultPreferences() {
		IPreferenceStore store = PlatformUI.getPreferenceStore();
		store.setDefault(InputPreferenceConstants.INPUT_VIEWER_NAME_LINETYPE,
				InputPreferenceConstants.INPUT_VIEWER_LINETYPE);
		store
				.setDefault(
						InputPreferenceConstants.INPUT_VIEWER_NAME_ASSOCIATION_LINEWIDTH,
						InputPreferenceConstants.INPUT_VIEWER_ASSOCIATION_LINEWIDTH);
		PreferenceConverter
				.setDefault(
						store,
						InputPreferenceConstants.INPUT_VIEWER_NAME_ASSOCIATION_LINECOLOR,
						InputPreferenceConstants.INPUT_VIEWER_ASSOCIATION_LINECOLOR);
		store
				.setDefault(
						InputPreferenceConstants.INPUT_VIEWER_NAME_REARRANGE_NODES_XDISTANCE,
						InputPreferenceConstants.INPUT_VIEWER_REARRANGE_NODES_XDISTANCE);
		store
				.setDefault(
						InputPreferenceConstants.INPUT_VIEWER_NAME_REARRANGE_NODES_YDISTANCE,
						InputPreferenceConstants.INPUT_VIEWER_REARRANGE_NODES_YDISTANCE);
		store
				.setDefault(
						InputPreferenceConstants.INPUT_VIEWER_NAME_REARRANGE_TREE_DISTANCE,
						InputPreferenceConstants.INPUT_VIEWER_REARRANGE_TREE_DISTANCE);

		store.setDefault(
				InputPreferenceConstants.INPUT_VIEWER_NAME_HOST_LINEWIDTH,
				InputPreferenceConstants.INPUT_VIEWER_HOST_LINEWIDTH);
		store.setDefault(
				InputPreferenceConstants.INPUT_VIEWER_NAME_HOST_NODEWIDTH,
				InputPreferenceConstants.INPUT_VIEWER_HOST_NODEWIDTH);
		store.setDefault(
				InputPreferenceConstants.INPUT_VIEWER_NAME_HOST_NODEHEIGHT,
				InputPreferenceConstants.INPUT_VIEWER_HOST_NODEHEIGHT);
		PreferenceConverter.setDefault(store,
				InputPreferenceConstants.INPUT_VIEWER_NAME_HOST_LINECOLOR,
				InputPreferenceConstants.INPUT_VIEWER_HOST_LINECOLOR);
		PreferenceConverter.setDefault(store,
				InputPreferenceConstants.INPUT_VIEWER_NAME_HOST_NODECOLOR,
				InputPreferenceConstants.INPUT_VIEWER_HOST_NODECOLOR);
		PreferenceConverter
				.setDefault(
						store,
						InputPreferenceConstants.INPUT_VIEWER_NAME_HOST_NODEOUTLINECOLOR,
						InputPreferenceConstants.INPUT_VIEWER_HOST_NODEOUTLINECOLOR);
		PreferenceConverter
				.setDefault(
						store,
						InputPreferenceConstants.INPUT_VIEWER_NAME_HOST_NODEHIGHLIGHTCOLOR,
						InputPreferenceConstants.INPUT_VIEWER_HOST_NODEHIGHLIGHTCOLOR);
		PreferenceConverter
				.setDefault(
						store,
						InputPreferenceConstants.INPUT_VIEWER_NAME_HOST_NODEFOLDSIGNCOLOR,
						InputPreferenceConstants.INPUT_VIEWER_HOST_NODEFOLDSIGNCOLOR);
		PreferenceConverter.setDefault(store,
				InputPreferenceConstants.INPUT_VIEWER_NAME_HOST_FONTCOLOR,
				InputPreferenceConstants.INPUT_VIEWER_HOST_FONTCOLOR);
		PreferenceConverter.setDefault(store,
				InputPreferenceConstants.INPUT_VIEWER_NAME_HOST_FONT,
				InputPreferenceConstants.INPUT_VIEWER_HOST_FONT);

		store.setDefault(
				InputPreferenceConstants.INPUT_VIEWER_NAME_PARASITE_LINEWIDTH,
				InputPreferenceConstants.INPUT_VIEWER_PARASITE_LINEWIDTH);
		store.setDefault(
				InputPreferenceConstants.INPUT_VIEWER_NAME_PARASITE_NODEWIDTH,
				InputPreferenceConstants.INPUT_VIEWER_PARASITE_NODEWIDTH);
		store.setDefault(
				InputPreferenceConstants.INPUT_VIEWER_NAME_PARASITE_NODEHEIGHT,
				InputPreferenceConstants.INPUT_VIEWER_PARASITE_NODEHEIGHT);
		PreferenceConverter.setDefault(store,
				InputPreferenceConstants.INPUT_VIEWER_NAME_PARASITE_LINECOLOR,
				InputPreferenceConstants.INPUT_VIEWER_PARASITE_LINECOLOR);
		PreferenceConverter.setDefault(store,
				InputPreferenceConstants.INPUT_VIEWER_NAME_PARASITE_NODECOLOR,
				InputPreferenceConstants.INPUT_VIEWER_PARASITE_NODECOLOR);
		PreferenceConverter
				.setDefault(
						store,
						InputPreferenceConstants.INPUT_VIEWER_NAME_PARASITE_NODEOUTLINECOLOR,
						InputPreferenceConstants.INPUT_VIEWER_PARASITE_NODEOUTLINECOLOR);
		PreferenceConverter
				.setDefault(
						store,
						InputPreferenceConstants.INPUT_VIEWER_NAME_PARASITE_NODEHIGHLIGHTCOLOR,
						InputPreferenceConstants.INPUT_VIEWER_PARASITE_NODEHIGHLIGHTCOLOR);
		PreferenceConverter
				.setDefault(
						store,
						InputPreferenceConstants.INPUT_VIEWER_NAME_PARASITE_NODEFOLDSIGNCOLOR,
						InputPreferenceConstants.INPUT_VIEWER_PARASITE_NODEFOLDSIGNCOLOR);
		PreferenceConverter.setDefault(store,
				InputPreferenceConstants.INPUT_VIEWER_NAME_PARASITE_FONTCOLOR,
				InputPreferenceConstants.INPUT_VIEWER_PARASITE_FONTCOLOR);
		PreferenceConverter.setDefault(store,
				InputPreferenceConstants.INPUT_VIEWER_NAME_PARASITE_FONT,
				InputPreferenceConstants.INPUT_VIEWER_PARASITE_FONT);
	}
}
