/**
 * 
 */
package com.wieseke.cptk.output.action;

import com.wieseke.cptk.output.constants.OutputActionConstants;
import com.wieseke.cptk.output.viewer.OutputCophylogenyViewer;
import com.wieseke.cptk.output.viewer.OutputNodeControl;

/**
 * @author Nicolas Wieseke
 * 
 */
public class EditFoldNodeAction extends OutputAction {

	/**
	 * default constructor
	 */
	public EditFoldNodeAction() {
		super(OutputActionConstants.FOLD_NODE_TEXT);
	}

	/**
	 * constructor
	 * 
	 * @param viewer
	 * @param node
	 */
	public EditFoldNodeAction(OutputCophylogenyViewer viewer,
			OutputNodeControl node) {
		super(OutputActionConstants.FOLD_NODE_TEXT);
		this.viewer = viewer;
		this.node = node;
	}

	public void run() {
		if (this.node != null)
			this.node.toggleExpandFlag();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.Action#setEnabled(boolean)
	 */
	
	public void setEnabled(boolean enabled) {
		if (enabled && node != null && !node.getNode().isLeaf()) {
			super.setEnabled(true);
		} else {
			super.setEnabled(false);
		}
	}
}