/**
 * 
 */
package com.wieseke.cptk.output.action;

import org.eclipse.jface.window.Window;
import org.eclipse.jface.wizard.WizardDialog;

import com.wieseke.cptk.output.dao.OutputCophylogeny;
import com.wieseke.cptk.output.viewer.OutputCophylogenyViewer;
import com.wieseke.cptk.output.wizards.ReconstructionChooseWizard;

/**
 * @author Nicolas Wieseke
 * 
 */
public class ReconstructionChooseAction extends OutputAction {

	/**
	 * default constructor
	 * 
	 * @param text
	 */
	public ReconstructionChooseAction(String text) {
		super(text);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 */

	public void run() {
		if (this.viewer != null) {
			if (this.viewer instanceof OutputCophylogenyViewer) {
				ReconstructionChooseWizard wizard = new ReconstructionChooseWizard(
						(OutputCophylogeny) this.viewer.getCophylogeny());
				WizardDialog dialog = new WizardDialog(this.viewer.getShell(),
						wizard);
				dialog.create();
				dialog.open();
				if (dialog.getReturnCode() == Window.OK) {
					((OutputCophylogenyViewer) this.viewer)
							.showChoosenReconstruction(wizard.getNumber());
				}
			}
		}
	}
}
