/**
 * 
 */
package com.wieseke.cptk.output.dao;

import java.util.List;

import com.wieseke.cptk.common.api.INode;
import com.wieseke.cptk.common.dao.PositionNode;
import com.wieseke.cptk.common.util.Tupel;

/**
 * @author Nicolas Wieseke
 * 
 */
public abstract class OutputNode extends PositionNode {

	public void setParent(OutputNode parent) {
		super.setParent(parent);
	}

	@SuppressWarnings("unchecked")
	
	public List<? extends OutputNode> getChildren() {
		return (List<OutputNode>) super.getChildren();
	}

	public OutputNode(INode node) {
		super();
		this.setLabel(node.getLabel());
		this.setLevel(node.getLevel());
		this.setNumber(node.getNumber());
		this.setChildrenCount(node.getChildrenCount());
	}

	/**
	 * calculates the positions for the descending nodes
	 * 
	 * @param nextLeafPosX
	 *            the x position of the next leaf
	 * @return a tupel containing the nextLeafPosX ant the nextPosY
	 */
	public abstract Tupel<Integer, Integer> calcNodePositions(int nextLeafPosX);

	public int renumberNodes(int number) {
		this.setNumber(number);
		number++;
		for (OutputNode child : getChildren()) {
			number = child.renumberNodes(number);
		}
		this.setChildrenCount(number - this.getNumber() - 1);
		return number;
	}

	public void renameNodes() {
		String label = ((this instanceof OutputHostNode) ? "H" : "P") + this.getNumber();
		this.setLabel(label);
		for (OutputNode child : getChildren()) {
			child.renameNodes();
		}
	}
}
