/**
 * 
 */
package com.wieseke.cptk.output.preferences;

import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.IntegerFieldEditor;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.eclipse.ui.PlatformUI;

/**
 * @author Nicolas Wieseke
 * 
 */
public class OutputPreferencePage extends FieldEditorPreferencePage implements
		IWorkbenchPreferencePage {

	public OutputPreferencePage() {
		super(GRID);
	}

	// private RadioGroupFieldEditor lineType;
	private IntegerFieldEditor rearrangeNodesXDistance;
	private IntegerFieldEditor rearrangeNodesYDistance;
	private IntegerFieldEditor parasiteShiftXDistance;
	private IntegerFieldEditor parasiteShiftYDistance;

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.preference.FieldEditorPreferencePage#createFieldEditors
	 * ()
	 */
	
	protected void createFieldEditors() {
		// String[][] labelAndValues = {
		// {
		// OutputPreferenceConstants.OUTPUT_VIEWER_LINETYPE_RIGHT_ANGLED_TEXT,
		// OutputPreferenceConstants.OUTPUT_VIEWER_LINETYPE_RIGHT_ANGLED },
		// {
		// OutputPreferenceConstants.OUTPUT_VIEWER_LINETYPE_ACUTE_ANGLED_TEXT,
		// OutputPreferenceConstants.OUTPUT_VIEWER_LINETYPE_ACUTE_ANGLED } };
		// this.lineType = new RadioGroupFieldEditor(
		// OutputPreferenceConstants.OUTPUT_VIEWER_NAME_LINETYPE,
		// OutputPreferenceConstants.OUTPUT_VIEWER_LINETYPE_TEXT, 2,
		// labelAndValues, getFieldEditorParent());
		// addField(this.lineType);

		this.rearrangeNodesXDistance = new IntegerFieldEditor(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_REARRANGE_NODES_XDISTANCE,
				OutputPreferenceConstants.OUTPUT_VIEWER_REARRANGE_NODES_XDISTANCE_TEXT,
				getFieldEditorParent());
		addField(this.rearrangeNodesXDistance);
		this.rearrangeNodesYDistance = new IntegerFieldEditor(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_REARRANGE_NODES_YDISTANCE,
				OutputPreferenceConstants.OUTPUT_VIEWER_REARRANGE_NODES_YDISTANCE_TEXT,
				getFieldEditorParent());
		addField(this.rearrangeNodesYDistance);

		this.parasiteShiftXDistance = new IntegerFieldEditor(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_SHIFT_XDISTANCE,
				OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_SHIFT_XDISTANCE_TEXT,
				getFieldEditorParent());
		this.parasiteShiftXDistance.setValidRange(Integer.MIN_VALUE,
				Integer.MAX_VALUE);
		addField(this.parasiteShiftXDistance);
		this.parasiteShiftYDistance = new IntegerFieldEditor(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_SHIFT_YDISTANCE,
				OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_SHIFT_YDISTANCE_TEXT,
				getFieldEditorParent());
		addField(this.parasiteShiftYDistance);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	
	public void init(IWorkbench workbench) {
		setPreferenceStore(PlatformUI.getPreferenceStore());
		setDescription("General preferences for visualizing reconstructions");
	}

}
