/**
 * 
 */
package com.wieseke.cptk.reconstruction.dao;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Nicolas Wieseke
 * 
 */
public class StaticCostTableItem {

	/**
	 * the cost value
	 */
	private BigDecimal cost;
	/**
	 * the number of used sortings
	 */
	private int sortings;
	/**
	 * flag indicating that a host switch occurred
	 */
	private boolean hostswitch;
	/**
	 * take-off side in case of a host switch
	 */
	private List<Integer> takeof;
	/**
	 * landing site in case of a host switch
	 */
	private List<Integer> landing;

	private boolean valid;

	public StaticCostTableItem(List<Integer> takeof, List<Integer> landing,
			BigDecimal cost, int sortings, boolean hostswitch, boolean valid) {
		this.cost = cost;
		this.takeof = takeof;
		this.landing = landing;
		this.sortings = sortings;
		this.hostswitch = hostswitch;
		this.valid = valid;
	}

	public StaticCostTableItem(int takeof, int landing, BigDecimal cost,
			int sortings, boolean hostswitch, boolean valid) {
		this.cost = cost;
		this.takeof = new ArrayList<Integer>();
		this.takeof.add(takeof);
		this.landing = new ArrayList<Integer>();
		this.landing.add(landing);
		this.sortings = sortings;
		this.hostswitch = hostswitch;
		this.valid = valid;
	}

	/**
	 * @return the cost
	 */
	public BigDecimal getCost() {
		return cost;
	}

	/**
	 * @param cost
	 *            the cost to set
	 */
	public void setCost(BigDecimal cost) {
		this.cost = cost;
	}

	/**
	 * @return the sortings
	 */
	public int getSortings() {
		return sortings;
	}

	/**
	 * @param sortings
	 *            the sortings to set
	 */
	public void setSortings(int sortings) {
		this.sortings = sortings;
	}

	/**
	 * @return the hostswitch
	 */
	public boolean isHostswitch() {
		return hostswitch;
	}

	/**
	 * @param hostswitch
	 *            the hostswitch to set
	 */
	public void setHostswitch(boolean hostswitch) {
		this.hostswitch = hostswitch;
	}

	/**
	 * @return the takeof
	 */
	public int getTakeof(int index) {
		return takeof.get(index);
	}

	/**
	 * @return the takeof
	 */
	public List<Integer> getTakeof() {
		return takeof;
	}

	/**
	 * @param takeoff
	 *            the takeof to set
	 */
	public void setTakeof(List<Integer> takeoff) {
		this.takeof = takeoff;
	}

	/**
	 * @return the landing
	 */
	public int getLanding(int index) {
		return landing.get(index);
	}

	/**
	 * @return the landing
	 */
	public List<Integer> getLanding() {
		return landing;
	}

	/**
	 * @param landing
	 *            the landing to set
	 */
	public void setLanding(List<Integer> landing) {
		this.landing = landing;
	}

	/**
	 * @return the valid
	 */
	public boolean isValid() {
		return valid;
	}

	/**
	 * @param valid
	 *            the valid to set
	 */
	public void setValid(boolean valid) {
		this.valid = valid;
	}

}
