/**
 * 
 */
package com.wieseke.cptk.reconstruction.job;

import java.util.Map;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;

import com.wieseke.cptk.common.dao.ReconstructionCosts;
import com.wieseke.cptk.input.dao.InputCophylogeny;
import com.wieseke.cptk.reconstruction.dao.ReconstructionCophylogeny;

/**
 * @author Nicolas Wieseke
 * 
 */
public class BaseSolverJob extends Job {

	private InputCophylogeny cophylogeny;
	private ReconstructionCosts costs;
	private Map<String, String> options;

	/**
	 * @param name
	 */
	public BaseSolverJob(String name, InputCophylogeny cophylogeny,
			ReconstructionCosts costs, Map<String, String> options) {
		super(name);
		this.cophylogeny = cophylogeny;
		this.costs = costs;
		this.options = options;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @seeorg.eclipse.core.runtime.jobs.Job#run(org.eclipse.core.runtime.
	 * IProgressMonitor)
	 */
	
	protected IStatus run(IProgressMonitor monitor) {
		ReconstructionCophylogeny reconstructionCophylogeny = new ReconstructionCophylogeny(
				this.cophylogeny, this.costs, this.options);
		System.out
				.println("Counter\tQuality\tTotalCost\tTotalEvents\tCoCost\tCoEvents\tCoProb\tCoFreq\tSoCost\tSoEvents\tSoProb\tSoFreq\tDuCost\tDuEvents\tDuProb\tDuFreq\tHsCost\tHsEvents\tHsProb\tHsFreq\tRootMapping");
		monitor.beginTask("Compute reconstruction", 100);
		reconstructionCophylogeny.compute(null, monitor, true);
		monitor.done();

		return Status.OK_STATUS;

	}

}
